<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Danh sách liên hệ</title>
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.6.2/dist/css/bootstrap.min.css"
        integrity="sha384-xOolHFLEh07PJGoPkLv1IbcEPTNtaed2xpHsD9ESMhqIYd0nLMwNLD69Npy4HI+N" crossorigin="anonymous">
    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.0.2/dist/css/bootstrap.min.css" rel="stylesheet"
        integrity="sha384-EVSTQN3/azprG1Anm3QDgpJLIm9Nao0Yz1ztcQTwFspd3yD65VohhpuuCOmLASjC" crossorigin="anonymous">
    <script src="https://cdn.jsdelivr.net/npm/jquery@3.5.1/dist/jquery.slim.min.js"
        integrity="sha384-DfXdz2htPH0lsSSs5nCTpuj/zy4C+OGpamoFVy38MVBnE+IbbVYUew+OrCXaRkfj"
        crossorigin="anonymous"></script>
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@4.6.2/dist/js/bootstrap.bundle.min.js"
        integrity="sha384-Fy6S3B9q64WdZWQUiU+q4/2Lc9npb8tCaSX9FK7E8HnRr0Jz8D6OP9dO5Vg3Q9ct"
        crossorigin="anonymous"></script>
    <style>
        * {
            box-sizing: border-box;
            margin: 0;
            padding: 0;
        }

        .table-striped>tbody>tr:nth-child(odd)>td,
        .table-striped>tbody>tr:nth-child(odd)>th {
            background-color: #d2deef;
        }

        .table-striped>tbody>tr:nth-child(even)>td,
        .table-striped>tbody>tr:nth-child(even)>th {
            background-color: #eaeff7;
        }

        .table {
            color: white;
            /* table-layout: auto;
            width: 100%; */
        }

        tbody>tr {
            color: black;
        }

        .table-bordered {
            border: 2px solid white;
        }

        td {
            word-break: break-word;
        }

        .table-striped>tbody>tr>td {
            border: 1.5px solid white;
        }

        .table-striped>thead>tr {
            border-bottom: 4px solid white;
        }

        .header {
            margin-bottom: 30px;
        }

        td:nth-child(1) {
            width: 5%;
        }

        td:nth-child(2) {
            width: 15%;

        }

        td:nth-child(3) {
            width: 22%;

        }

        td:nth-child(4) {
            width: 30%;

        }

        td:nth-child(5) {
            width: 14%;

        }
    </style>
</head>

<body onload="onPageLoading()">
    <div class="container-fluid">
        <div class="header text-center">
            <h1>DANH SÁCH LIÊN HỆ</h1>
        </div>
        <div class="col-sm-12 table-responsive">
            <table class="admin-user table table-striped border-white table-bordered table-hover">
                <thead class="border-2">
                    <tr class="" style="background-color: #5b9bd5;font-size: 20px;">
                        <th>STT</th>
                        <th>Name</th>
                        <th>Email</th>
                        <th>Message</th>
                        <th>Ngày liên hệ</th>
                        <th>Action</th>
                    </tr>
                </thead>
                <tbody>

                </tbody>
            </table>
        </div>
    </div>
    <script>
        /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
        const gREQUEST_STATUS_OK = 200;
        const gREQUEST_CREATE_OK = 201; // status 201 là tạo mới thành công
        const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
        const gBASE_URL = "https://62442d9d3da3ac772b0c50eb.mockapi.io/api/v1/";
        const gEND_ROW_TABLE = -1;
        const gEND_ROW_COL = -1;
        /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
        /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
        function onPageLoading() {
            //Call Api get contact
            var vAPI_URL = gBASE_URL + "/contacts";
            var vXhttp = new XMLHttpRequest();
            vXhttp.onreadystatechange = function () {
                if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                    console.log(vXhttp.responseText);
                    vResponseObj = JSON.parse(vXhttp.responseText);
                    hienthiDuLieuTable(vResponseObj);
                    addEventListenerToButtonSua();
                    addEventListenerToButtonXoa()
                }
            };
            vXhttp.open("GET", vAPI_URL, true);
            vXhttp.send();
        }

        /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
        // Hàm hiển thị dữ liệu lên table
        function hienthiDuLieuTable(paramContactObj) {
            //debugger
            var vTable = document.getElementById("admin-user");
            var vTableBody = document.getElementsByTagName("tbody")[0];

            for (let bI = 0; bI < paramContactObj.length; bI++) {
                var vNewRow = vTableBody.insertRow(gEND_ROW_TABLE);
                var vSTT = vNewRow.insertCell(gEND_ROW_COL);
                var vName = vNewRow.insertCell(gEND_ROW_COL);
                var vEmail = vNewRow.insertCell(gEND_ROW_COL);
                var vMessage = vNewRow.insertCell(gEND_ROW_COL);
                var vContactDate = vNewRow.insertCell(gEND_ROW_COL);
                var vAction = vNewRow.insertCell(gEND_ROW_COL);

                vSTT.innerHTML = bI + 1;
                vName.innerHTML = paramContactObj[bI].name;
                vEmail.innerHTML = paramContactObj[bI].email;
                vMessage.innerHTML = paramContactObj[bI].message;
                vContactDate.innerHTML = paramContactObj[bI].createDate;

                var vSuaButton = document.createElement("button");
                vSuaButton.className = "btn btn-success sua-btn"
                vSuaButton.textContent = "Sửa";
                vSuaButton.style.width = "65px";
                vSuaButton.style.marginRight = "10px"
                vSuaButton.setAttribute("data-id", paramContactObj[bI].id)

                var vXoaButton = document.createElement("button");
                vXoaButton.className = "btn btn-danger xoa-btn"
                vXoaButton.textContent = "Xóa";
                vXoaButton.style.width = "65px";
                vXoaButton.setAttribute("data-id", paramContactObj[bI].id)

                vAction.appendChild(vSuaButton);
                vAction.appendChild(vXoaButton);
            }
        }

        // Hàm thêm sự kiện cho nút Sửa button
        function addEventListenerToButtonSua() {
            var vSuaButton = document.getElementsByClassName("sua-btn");
            for (let bI = 0; bI < vSuaButton.length; bI++) {
                vSuaButton[bI].addEventListener("click", function () {
                    //debugger
                    var vContactId = this.dataset.id;
                    console.log(vContactId)
                    const vURLOpenToSiteContactDetail = "contactDetail.html";
                    window.location.href = vURLOpenToSiteContactDetail + "?" + "id=" + vContactId;
                })
            }

        }
        // Hàm thêm sự kiện cho nút xóa button
        function addEventListenerToButtonXoa() {
            var vXoaButton = document.getElementsByClassName("xoa-btn");
            for (let bI = 0; bI < vXoaButton.length; bI++) {
                vXoaButton[bI].addEventListener("click", function () {
                    var vContactId = this.dataset.id;
                    console.log(vContactId);
                    if (confirm("Bạn có chắc chắn muốn xóa Liên hệ này không?") === true) {
                        // Gọi hàm Api xóa contact theo Id
                        callApiDeleteContactById(vContactId);
                    }
                })
            }
        }


        // Hàm gọi Api xóa contact
        function callApiDeleteContactById(paramContactId) {
            const vAPI_URL = gBASE_URL + "/contacts/";
            var vXmlhttp = new XMLHttpRequest();
            vXmlhttp.open("DELETE", vAPI_URL + paramContactId, true);
            vXmlhttp.send();

            vXmlhttp.onreadystatechange = function () {
                // xóa thành công contact
                if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                    alert("Delete contact " + paramContactId + " thành công!");
                    window.location.href = "listContact.html";
                }
            }
        }
    </script>
</body>

</html>